/*
 * FxGLUT version 0.12 - GLUT for Voodoo 1 and 2 under Linux
 * Copyright (C) 1999 Christopher John Purnell
 *                    cjp@lost.org.uk
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __GLUT_H__
#define __GLUT_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <GL/gl.h>
#include <GL/glu.h>

#define GLUT_RGB			0
#define GLUT_RGBA			GLUT_RGB
#define GLUT_INDEX			1
#define GLUT_SINGLE			0
#define GLUT_DOUBLE			2
#define GLUT_ACCUM			4
#define GLUT_ALPHA			8
#define GLUT_DEPTH			16
#define GLUT_STENCIL			32

#define GLUT_LEFT_BUTTON		0
#define GLUT_MIDDLE_BUTTON		1
#define GLUT_RIGHT_BUTTON		2

#define GLUT_DOWN			0
#define GLUT_UP				1

#define GLUT_KEY_F1			1
#define GLUT_KEY_F2			2
#define GLUT_KEY_F3			3
#define GLUT_KEY_F4			4
#define GLUT_KEY_F5			5
#define GLUT_KEY_F6			6
#define GLUT_KEY_F7			7
#define GLUT_KEY_F8			8
#define GLUT_KEY_F9			9
#define GLUT_KEY_F10			10
#define GLUT_KEY_F11			11
#define GLUT_KEY_F12			12
#define GLUT_KEY_LEFT			100
#define GLUT_KEY_UP			101
#define GLUT_KEY_RIGHT			102
#define GLUT_KEY_DOWN			103
#define GLUT_KEY_PAGE_UP		104
#define GLUT_KEY_PAGE_DOWN		105
#define GLUT_KEY_HOME			106
#define GLUT_KEY_END			107
#define GLUT_KEY_INSERT			108

#define GLUT_LEFT			0
#define GLUT_ENTERED			1

#define GLUT_MENU_NOT_IN_USE		0
#define GLUT_MENU_IN_USE		1

#define GLUT_NOT_VISIBLE		0
#define GLUT_VISIBLE			1

#define GLUT_WINDOW_X			100
#define GLUT_WINDOW_Y			101
#define GLUT_WINDOW_WIDTH		102
#define GLUT_WINDOW_HEIGHT		103
#define GLUT_WINDOW_CURSOR		122
#define GLUT_SCREEN_WIDTH		200
#define GLUT_SCREEN_HEIGHT		201
#define GLUT_INIT_WINDOW_X		500
#define GLUT_INIT_WINDOW_Y		501
#define GLUT_INIT_WINDOW_WIDTH		502
#define GLUT_INIT_WINDOW_HEIGHT		503
#define GLUT_INIT_DISPLAY_MODE		504
#define GLUT_ELAPSED_TIME		700
#define GLUT_WINDOW_FORMAT_ID		123

#define GLUT_HAS_KEYBOARD		600
#define GLUT_HAS_MOUSE			601
#define GLUT_HAS_SPACEBALL		602
#define GLUT_HAS_DIAL_AND_BUTTON_BOX	603
#define GLUT_HAS_TABLET			604
#define GLUT_NUM_MOUSE_BUTTONS		605
#define GLUT_NUM_SPACEBALL_BUTTONS	606
#define GLUT_NUM_BUTTON_BOX_BUTTONS	607
#define GLUT_NUM_DIALS			608
#define GLUT_NUM_TABLET_BUTTONS		609
#define GLUT_DEVICE_IGNORE_KEY_REPEAT   610
#define GLUT_DEVICE_KEY_REPEAT          611
#define GLUT_HAS_JOYSTICK		612
#define GLUT_OWNS_JOYSTICK		613
#define GLUT_JOYSTICK_BUTTONS		614
#define GLUT_JOYSTICK_AXES		615
#define GLUT_JOYSTICK_POLL_RATE		616

#define GLUT_ACTIVE_SHIFT		1
#define GLUT_ACTIVE_CTRL		2
#define GLUT_ACTIVE_ALT			4

#define GLUT_CURSOR_RIGHT_ARROW		0
#define GLUT_CURSOR_LEFT_ARROW		1
#define GLUT_CURSOR_INFO		2
#define GLUT_CURSOR_DESTROY		3
#define GLUT_CURSOR_HELP		4
#define GLUT_CURSOR_CYCLE		5
#define GLUT_CURSOR_SPRAY		6
#define GLUT_CURSOR_WAIT		7
#define GLUT_CURSOR_TEXT		8
#define GLUT_CURSOR_CROSSHAIR		9
#define GLUT_CURSOR_UP_DOWN		10
#define GLUT_CURSOR_LEFT_RIGHT		11
#define GLUT_CURSOR_TOP_SIDE		12
#define GLUT_CURSOR_BOTTOM_SIDE		13
#define GLUT_CURSOR_LEFT_SIDE		14
#define GLUT_CURSOR_RIGHT_SIDE		15
#define GLUT_CURSOR_TOP_LEFT_CORNER	16
#define GLUT_CURSOR_TOP_RIGHT_CORNER	17
#define GLUT_CURSOR_BOTTOM_RIGHT_CORNER	18
#define GLUT_CURSOR_BOTTOM_LEFT_CORNER	19
#define GLUT_CURSOR_INHERIT		100
#define GLUT_CURSOR_NONE		101
#define GLUT_CURSOR_FULL_CROSSHAIR	102

#define GLUT_KEY_REPEAT_OFF		0
#define GLUT_KEY_REPEAT_ON		1
#define GLUT_KEY_REPEAT_DEFAULT		2

extern void glutInit(int *argcp, char **argv);
extern void glutInitDisplayMode(unsigned int mode);
extern void glutInitWindowPosition(int x, int y);
extern void glutInitWindowSize(int width, int height);
extern void glutMainLoop(void);

extern int glutCreateWindow(const char *title);
extern void glutDestroyWindow(int win);
extern void glutSetWindow(int win);
extern int glutGetWindow(void);
extern void glutSwapBuffers(void);
extern void glutPostRedisplay(void);
extern void glutPostWindowRedisplay(int win);

extern void glutIgnoreKeyRepeat(int ignore);
extern void glutSetKeyRepeat(int repeateMode);
extern int glutGetModifiers(void);

extern int glutCreateMenu(void (*func)(int));
extern void glutDestroyMenu(int menu);
extern int glutGetMenu(void);
extern void glutSetMenu(int menu);
extern void glutAddMenuEntry(const char *label, int value);
extern void glutAddSubMenu(const char *label, int submenu);
extern void glutChangeToMenuEntry(int item, const char *label, int value);
extern void glutChangeToSubMenu(int item, const char *label, int submenu);
extern void glutRemoveMenuItem(int item);
extern void glutAttachMenu(int button);
extern void glutDetachMenu(int button);
extern void glutMenuStatusFunc(void (*func)(int status, int x, int y));
extern void glutMenuStateFunc(void (*func)(int status));

extern void glutIdleFunc(void (*func)(void));
extern void glutTimerFunc(unsigned int millis, void (*func)(int value), int value);
extern void glutDisplayFunc(void (*func)(void));
extern void glutReshapeFunc(void (*func)(int width, int height));
extern void glutEntryFunc(void (*func)(int state));
extern void glutVisibilityFunc(void (*func)(int state));
extern void glutKeyboardFunc(void (*func)(unsigned char key, int x, int y));
extern void glutKeyboardUpFunc(void (*func)(unsigned char key, int x, int y));
extern void glutSpecialFunc(void (*func)(int key, int x, int y));
extern void glutSpecialUpFunc(void (*func)(int key, int x, int y));

extern void glutMouseFunc(void (*func)(int button, int state, int x, int y));
extern void glutMotionFunc(void (*func)(int x, int y));
extern void glutPassiveMotionFunc(void (*func)(int x, int y));
extern void glutWarpPointer(int x, int y);

extern int glutGet(int state);
extern int glutDeviceGet(int info);
extern int glutExtensionSupported(const char *name);
extern void glutReportErrors(void);

/* Null functions */

extern void glutFullScreen(void);
extern void glutSetWindowTitle(char *name);
extern void glutSetIconTitle(char *name);
extern void glutPositionWindow(int x, int y);
extern void glutReshapeWindow(int width, int height);
extern void glutPopWindow(void);
extern void glutPushWindow(void);
extern void glutSetCursor(int cursor);
extern void glutIconifyWindow(void);
extern void glutShowWindow(void);
extern void glutHideWindow(void);

/* Game mode */

#define GLUT_GAME_MODE_ACTIVE		0
#define GLUT_GAME_MODE_POSSIBLE		1
#define GLUT_GAME_MODE_WIDTH		2
#define GLUT_GAME_MODE_HEIGHT		3
#define GLUT_GAME_MODE_PIXEL_DEPTH	4
#define GLUT_GAME_MODE_REFRESH_RATE	5

extern void glutGameModeString(const char *string);
extern int glutEnterGameMode(void);
extern void glutLeaveGameMode(void);
extern int glutGameModeGet(int mode);

/* Bitmap Fonts */

extern void *glutBitmap9By15;
extern void *glutBitmap8By13;
extern void *glutBitmapTimesRoman10;
extern void *glutBitmapTimesRoman24;
extern void *glutBitmapHelvetica10;
extern void *glutBitmapHelvetica12;
extern void *glutBitmapHelvetica18;

#define GLUT_BITMAP_9_BY_15		(&glutBitmap9By15)
#define GLUT_BITMAP_8_BY_13		(&glutBitmap8By13)
#define GLUT_BITMAP_TIMES_ROMAN_10	(&glutBitmapTimesRoman10)
#define GLUT_BITMAP_TIMES_ROMAN_24	(&glutBitmapTimesRoman24)
#define GLUT_BITMAP_HELVETICA_10	(&glutBitmapHelvetica10)
#define GLUT_BITMAP_HELVETICA_12	(&glutBitmapHelvetica12)
#define GLUT_BITMAP_HELVETICA_18	(&glutBitmapHelvetica18)

void glutBitmapCharacter(void *, int);
void glutBitmapString(void *, const unsigned char *);
int glutBitmapWidth(void *, int);
int glutBitmapLength(void *, const unsigned char *);
int glutBitmapHeight(void *);
int glutBitmapDescent(void *);

/* Stroke Fonts */

extern void *glutStrokeRoman;
extern void *glutStrokeMonoRoman;

#define GLUT_STROKE_ROMAN		(&glutStrokeRoman)
#define GLUT_STROKE_MONO_ROMAN		(&glutStrokeMonoRoman)

void glutStrokeCharacter(void *, int);
void glutStrokeString(void *, const unsigned char *);
int glutStrokeWidth(void *, int);
int glutStrokeLength(void *, const unsigned char *);
GLfloat glutStrokeHeight(void *);
GLfloat glutStrokeDescent(void *);

/* Shapes */

void glutWireSphere(GLdouble, GLint, GLint);
void glutSolidSphere(GLdouble, GLint, GLint);
void glutWireCone(GLdouble, GLdouble, GLint, GLint);
void glutSolidCone(GLdouble, GLdouble, GLint, GLint);
void glutWireCube(GLdouble);
void glutSolidCube(GLdouble);
void glutWireTorus(GLdouble, GLdouble, GLint, GLint);
void glutSolidTorus(GLdouble, GLdouble, GLint, GLint);
void glutWireDodecahedron(void);
void glutSolidDodecahedron(void);
void glutWireTeapot(GLdouble);
void glutSolidTeapot(GLdouble);
void glutWireOctahedron(void);
void glutSolidOctahedron(void);
void glutWireTetrahedron(void);
void glutSolidTetrahedron(void);
void glutWireIcosahedron(void);
void glutSolidIcosahedron(void);

#ifdef __cplusplus
}
#endif

#endif /* __GLUT_H__ */
