/*
 * FxGLUT version 0.9 - GLUT for Voodoo 1 and 2 under Linux
 * Copyright (C) 1999 Christopher John Purnell
 *                    cjp@lost.org.uk
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "internal.h"

int glutGet(int state)
{
	switch (state)
	{
	case GLUT_WINDOW_X:
		return 0;
	case GLUT_WINDOW_Y:
		return 0;
	case GLUT_WINDOW_WIDTH:
		return __glutContext ? __glutWindowWidth : -1;
	case GLUT_WINDOW_HEIGHT:
		return __glutContext ? __glutWindowHeight : -1;
	case GLUT_WINDOW_CURSOR:
		return __glutSelectedCursor;
	case GLUT_SCREEN_WIDTH:
		return __glutWindowWidth;
	case GLUT_SCREEN_HEIGHT:
		return __glutWindowHeight;
	case GLUT_INIT_WINDOW_X:
		return __glutInitX;
	case GLUT_INIT_WINDOW_Y:
		return __glutInitY;
	case GLUT_INIT_WINDOW_WIDTH:
		return __glutInitWidth;
	case GLUT_INIT_WINDOW_HEIGHT:
		return __glutInitHeight;
	case GLUT_INIT_DISPLAY_MODE:
		return __glutDisplayMode;

	case GLUT_ELAPSED_TIME:
	{
		struct timeval then, now;
		int elapsed;

		__glutGetTime(&then);
		gettimeofday(&now, 0);

		elapsed = (now.tv_usec - then.tv_usec) / 1000;
		elapsed += (now.tv_sec - then.tv_sec) * 1000;

		return elapsed;
	}
	default:
		return -1;
	}
}

int glutDeviceGet(int info)
{
	switch (info)
	{
	case GLUT_HAS_KEYBOARD:
		return __glutKeyFD >= 0;
	case GLUT_HAS_MOUSE:
		return __glutMouseFD >= 0;
	case GLUT_NUM_MOUSE_BUTTONS:
		return __glutMouseFD >= 0 ? 3 : 0;
	case GLUT_DEVICE_IGNORE_KEY_REPEAT:
		return __glutIgnoreKeyRepeat;
	case GLUT_DEVICE_KEY_REPEAT:
		return GLUT_KEY_REPEAT_DEFAULT;
	default:
		return 0;
	}
}
