/*
 * FxGLUT version 0.9 - GLUT for Voodoo 1 and 2 under Linux
 * Copyright (C) 1999 Christopher John Purnell
 *                    cjp@lost.org.uk
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __GLUT_INTERNAL_H__
#define __GLUT_INTERNAL_H__

#include <sys/types.h>
#include <sys/time.h>

#include <GL/glut.h>
#include <GL/fxmesa.h>

#define GLUT_NEED_RESHAPE	1
#define GLUT_NEED_DISPLAY	2
#define GLUT_NEED_ENTRY		4

extern char * __glutProgramName;
extern int __glutDisplay;
extern unsigned int __glutDisplayMode;
extern int __glutInitX;
extern int __glutInitY;
extern int __glutInitWidth;
extern int __glutInitHeight;

extern unsigned int __glutPending;
extern void (*__glutIdleFunc)(void);
extern void (*__glutEntryFunc)(int); 
extern void (*__glutVisibilityFunc)(int);
extern void (*__glutReshapeFunc)(int, int);
extern void (*__glutDisplayFunc)(void);

extern fxMesaContext __glutContext;
extern int __glutWindowWidth;
extern int __glutWindowHeight;

extern int __glutFocus;
extern int __glutKeyFD;
extern int __glutIgnoreKeyRepeat;

extern int __glutMouseFD;
extern int __glutMouseX;
extern int __glutMouseY;

extern int __glutSelectedCursor;
extern int __glutCurrentCursor;

extern void __glutOpenDisplay(void);
extern void __glutGetTime(struct timeval *);

extern void __glutOpenKeyboard(void);
extern void __glutCloseKeyboard(void);
extern void __glutCheckKeyboard(void);

extern void __glutOpenMouse(void);
extern void __glutCloseMouse(void);
extern void __glutCheckMouse(void);

extern int __glutCreateWindow(GrScreenResolution_t, GrScreenRefresh_t, int, int);
extern void __glutDestroyWindow(void);

extern void __glutSetCursor(int);
extern void __glutDrawCursor(void);

#endif /* __GLUT_INTERNAL_H__ */
