/*
 * FxGLUT version 0.9 - GLUT for Voodoo 1 and 2 under Linux
 * Copyright (C) 1999 Christopher John Purnell
 *                    cjp@lost.org.uk
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <string.h>
#include <stdio.h>
#include "internal.h"

int glutExtensionSupported(const char *extension)
{
	static const char *extensions = 0;
	const char *ptr;

	if (!extension || !extension[0] || strchr(extension, ' '))
		return 0;

	if (!extensions)
	{
		if ( !(extensions = glGetString(GL_EXTENSIONS)) )
			return 0;
	}

	for (ptr = extensions; *ptr;)
	{
		const char *str = extension;
		char c;

		while ( (c = *(str++)) )
		{
			if (*ptr != c)
				goto next;
			ptr++;
		}
		if ( !(c = *ptr) || c == ' ' )
			return 1;
	next:
		while ( (c = *ptr) && c != ' ' )
			ptr++;
		while (*ptr == ' ')
			ptr++;
	}

	return 0;
}

void glutReportErrors(void)
{
	GLenum error;

	while ((error = glGetError()) != GL_NO_ERROR)
	{
		fprintf(stderr, "GL error: %s\n", gluErrorString(error));
	}
}
